<md-dialog flex="50" aria-label="Tests runs filter" class="runs-filter-modal styled-modal">
    <md-toolbar class="runs-filter-modal__header modal-header">
        <div class="runs-filter-modal__header-wrapper md-toolbar-tools modal-header__wrapper">
            <h2 id="modalTitle" class="modal-header__title">Filters</h2>
            <span flex></span>
            <md-button id="close" class="md-icon-button _default-md-style" ng-click="$ctrl.cancel()">
                <md-icon aria-label="Close dialog">close</md-icon>
            </md-button>
        </div>
    </md-toolbar>

    <md-dialog-content class="runs-filter-modal__content modal-content">
        <div class="runs-filter-modal__content-wrapper md-dialog-content modal-content__wrapper">
            <div class="runs-filter-modal__control-wrapper">
                <!--TODO: add clear (x) button-->
                <md-input-container class="runs-filter-modal__control-item runs-filter__search _with-icon _without-animation">
                    <label class="runs-filter-modal__search-label placeholder-label">Search items</label>
                    <input type="text"
                        class="runs-filter-modal__search-input"
                        ng-model="$ctrl.searchParams.query"
                        ng-model-options="{debounce: $ctrl.debounceDelay}"
                        ng-change="$ctrl.onFilterChange()"
                        aria-label="Search items"
                        aria-describedby="basic-addon2">
                    <i class="runs-filter-modal__search-icon material-icons">
                        search
                    </i>
                </md-input-container>
            </div>
            <div class="runs-filter-modal__control-wrapper"
                ng-repeat="visibleSearchControl in $ctrl.visibleSearchControls track by visibleSearchControl.id"
                ng-class="{ _active: $ctrl.isControlActive(visibleSearchControl) }">
                <md-button class="md-icon-button _default-md-style md-no-ink"
                    ng-if="!visibleSearchControl.isDefault"
                    ng-click="$ctrl.hideControl(visibleSearchControl)">
                    <md-icon aria-label="remove control">close</md-icon>
                </md-button>
                <md-input-container class="runs-filter-modal__control-item _select select-wrapper without-animation"
                    ng-if="visibleSearchControl.type === 'select'">
                    <md-select ng-attr-id="{{visibleSearchControl.id}}"
                        ng-attr-name="{{visibleSearchControl.key}}"
                        ng-attr-placeholder="{{visibleSearchControl.label}}"
                        ng-class="{ '_with-close-btn': !visibleSearchControl.isDefault }"
                        ng-model="$ctrl.searchParams[visibleSearchControl.key]"
                        class="runs-filter-modal__control-select _small"
                        md-selected-html="$ctrl.getSelectControlText(visibleSearchControl)"
                        md-on-close="$ctrl.onFilterChange()"
                        multiple>
                        <md-option ng-repeat="optionValue in visibleSearchControl.options"
                            ng-value="::optionValue">{{ optionValue }}</md-option>
                        <div class="runs-filter-modal__control-select-clear"
                            ng-click="$ctrl.clearControl(visibleSearchControl)">Clear</div>
                    </md-select>
                </md-input-container>
                <md-input-container class="runs-filter-modal__control-item _date"
                    ng-class="{ _active: $ctrl.isDateSearchActive}"
                    ng-if="visibleSearchControl.type === 'datePicker'">
                    <md-button ng-attr-id="{{visibleSearchControl.id}}"
                        class="_small _right-icon md-no-ink"
                        ng-click="$ctrl.showDatePickerDialog($event, true)">
                    <span class="md-button__text"
                        ng-if="$ctrl.selectedRange.selectedTemplateName">
                        {{visibleSearchControl.label}}: <strong>{{$ctrl.selectedRange.selectedTemplateName}}</strong>
                    </span>
                        <span class="md-button__text"
                            ng-if="!$ctrl.selectedRange.selectedTemplateName">
                        {{visibleSearchControl.label}}
                    </span>
                        <i class="material-icons">date_range</i>
                    </md-button>
                </md-input-container>
                <md-input-container class="runs-filter-modal__control-item _button"
                    ng-class="{ _active: $ctrl.searchParams[visibleSearchControl.key]}"
                    ng-if="visibleSearchControl.type === 'button'">
                    <md-button class="_small md-no-ink"
                        ng-click="visibleSearchControl.onClick()">
                        {{visibleSearchControl.label}}
                    </md-button>
                </md-input-container>

            </div>
            <div class="runs-filter-modal__control-wrapper">
                <md-menu md-offset="30 20" class="runs-filter__control-item runs-filter__more-menu">
                    <md-button class="runs-filter__action-button runs-filter__more-button _left-icon _small"
                        aria-label="Add more controls"
                        ng-click="$mdMenu.open($event)"><md-icon>add</md-icon>More</md-button>
                    <md-menu-content class="runs-filter-modal__more-menu-content">
                        <md-menu-item class="runs-filter-modal__more-menu-item"
                            ng-repeat="hidingSearchControl in $ctrl.hidingSearchControls track by hidingSearchControl.id">
                            <md-checkbox ng-model="hidingSearchControl.isVisible"
                                class="runs-filter-modal__more-menu-checkbox"
                                aria-label="Disabled control">
                                {{hidingSearchControl.label}}
                            </md-checkbox>
                        </md-menu-item>
                        <md-menu-item class="runs-filter-modal__more-menu-item _separated">
                            <md-button ng-click="$ctrl.clearAllControls()"
                                class="runs-filter-modal__more-menu-close"
                                aria-label="Close menu">Clear</md-button>
                        </md-menu-item>
                    </md-menu-content>
                </md-menu>
            </div>
        </div>
    </md-dialog-content>
    <md-dialog-actions class="styled-modal__controls-wrapper">
        <md-button ng-if="$ctrl.isSearchActive"
            ng-click="$ctrl.onSearchSave();">SAVE</md-button>
        <md-button ng-disabled="!$ctrl.isSearchActive"
            class="md-raised"
            ng-click="$ctrl.resetSearch();">RESET</md-button>
        <md-button
            ng-disabled="!$ctrl.isSearchActive && !$ctrl.isSearchChanged"
            class="md-raised md-primary"
            ng-click="$ctrl.onSearchApply();">APPLY</md-button>
    </md-dialog-actions>
</md-dialog>
